%global codename fuerte
%global shortname dynamic_reconfigure

# Turn off the brp-python-bytecompile script
# We have to do this, else it tries to bytecompile a python template file. :/
%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')

Name:		ros-%{codename}-dynamic-reconfigure
Version:	1.4.0
Release:	1%{?dist}
Summary:	Standard way of exposing ROS node params for dynamic reconfig
License:	BSD
URL:		http://ros.org/wiki/dynamic_reconfigure
Source0:	https://code.ros.org/svn/release/download/stacks/dynamic_reconfigure/dynamic_reconfigure-%{version}/dynamic_reconfigure-%{version}.tar.bz2
BuildRequires:	ros-%{codename}-ros-devel, ros-%{codename}-ros-comm-devel
BuildRequires:	cmake, python-yaml, wxPython-devel
BuildRequires:	chrpath
Provides:	ros-%{shortname} = %{version}-%{release}
Provides:	ros-dynamic-reconfigure = %{version}-%{release}

%description
At present, the focus of dynamic_reconfigure is on providing a standard way to 
expose a subset of a node's parameters to external reconfiguration. Client 
programs, e.g., GUIs, can query the node for the set of reconfigurable 
parameters, including their names, types, and ranges, and present a customized 
interface to the user. This is especially useful for hardware drivers, but has 
broader applicability. 

%package devel
Summary:	Development files for ROS dynamic_reconfigure
Requires:	wxPython-devel, ros-%{codename}-ros-devel, ros-%{codename}-ros-comm-devel
Requires:	%{name} = %{version}-%{release}
Provides:	ros-%{shortname}-devel = %{version}-%{release}
Provides:	ros-dynamic-reconfigure-devel = %{version}-%{release}

%description devel
Development files for ROS dynamic_reconfigure.

%prep
%setup -q -c
# We have to do this so the cmake gunk can find itself. So idiotic.
mv %{shortname}-%{version} %{shortname}

%build
cd %{shortname}
source /etc/catkin/profile.d/10.ros.all
export ROS_PACKAGE_PATH="%{_builddir}/%{name}-%{version}:$ROS_PACKAGE_PATH"
mkdir build
cd build
%cmake -DSETUPTOOLS_DEB_LAYOUT=OFF ..
make %{?_smp_mflags}

%install
cd %{shortname}

mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/lib
mkdir -p %{buildroot}%{_libdir}/
cp -a lib/* %{buildroot}%{_libdir}/
ln -s %{_libdir}/libdynamic_reconfigure_config_init_mutex.so %{buildroot}%{_datadir}/ros-stacks/%{shortname}/lib/libdynamic_reconfigure_config_init_mutex.so

mkdir -p %{buildroot}%{python_sitelib}
cp -a src/dynamic_reconfigure/ %{buildroot}%{python_sitelib}
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/src/
ln -s %{python_sitelib}/dynamic_reconfigure %{buildroot}%{_datadir}/ros-stacks/%{shortname}/src/dynamic_reconfigure

mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/include
cp -a include/%{shortname} %{buildroot}%{_datadir}/ros-stacks/%{shortname}/include
cp -a docs msg msg_gen srv srv_gen *.xml cfg cmake templates %{buildroot}%{_datadir}/ros-stacks/%{shortname}/

mkdir -p %{buildroot}%{_bindir}
cp -a bin/testserver %{buildroot}%{_bindir}/ros-dynamic-reconfigure-testserver
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/bin
ln -s %{_bindir}/ros-dynamic-reconfigure-testserver %{buildroot}%{_datadir}/ros-stacks/%{shortname}/bin/testserver

# Bye bye rpath.
chrpath -d %{buildroot}%{_bindir}/ros-dynamic-reconfigure-testserver

# Manually invoke the python byte compile macro for each path that needs byte
# compilation.
%py_byte_compile %{__python} %{buildroot}%{python_sitelib}

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%{_bindir}/ros-dynamic-reconfigure-testserver
%{_datadir}/ros-stacks/%{shortname}/
%exclude %{_datadir}/ros-stacks/%{shortname}/include
%{_libdir}/libdynamic_reconfigure_config_init_mutex.so
%{python_sitelib}/dynamic_reconfigure

%files devel
%{_datadir}/ros-stacks/%{shortname}/include

%changelog
* Tue May 22 2012 Tom Callaway <spot@fedoraproject.org> - 1.4.0-1
- initial package
